# -*- coding:Utf-8 -*-
# hit_stat V1.102p by DoCky (04/05/09)

import es, langlib, popuplib

hs_info = es.AddonInfo()
hs_info.version = "1.102p"
hs_info.author = "DoCky"
hs_info.name = "hit_stat"
hs_info.url = "http://addons.eventscripts.com/addons/user/11751"

version = es.ServerVar(hs_info.name, hs_info.version, "By DoCky -")
version.set(hs_info.version)
version.makepublic()

popupList = set()
damage = {}




#  LANG
def loadString(pathern):
    global language
    language = langlib.Strings(pathern)

def getString(string, userid, options = {}):
    try: lang = langlib.getLangAbbreviation(es.createplayerlist(userid)[int(userid)]["language"])
    except: lang = langlib.getDefaultLang()
    return language(string, options, lang)




#  EVENT
def unload():
    for popupName in popupList: popuplib.delete(popupName)

def init():
    loadString(es.getAddonPath("hit_stat") + "/language.ini")
    for popupName in popupList: popuplib.delete(popupName)
    popupList.clear()
    damage.clear()

def load():
    init()

def es_map_start(event):
    init()

def player_hurt(event):
    global damage
    if event["es_userteam"] != event["es_attackerteam"] and event["attacker"] != "0":
        if not damage.has_key(event["userid"]) : damage[event["userid"]] = ({}, {}, [])
        if not damage[event["userid"]][0].has_key(event["es_attackername"]):
            damage[event["userid"]][0][event["es_attackername"]] = ([0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0])
        hitgroup = damage[event["userid"]][0][event["es_attackername"]][int(event["hitgroup"])]
        hitgroup[0] += 1
        hitgroup[1] += int(event["dmg_health"])

        if not damage.has_key(event["attacker"]) : damage[event["attacker"]] = ({}, {}, [])
        if not damage[event["attacker"]][1].has_key(event["es_username"]):
            damage[event["attacker"]][1][event["es_username"]] = ([0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0])
        hitgroup = damage[event["attacker"]][1][event["es_username"]][int(event["hitgroup"])]
        hitgroup[0] += 1
        hitgroup[1] += int(event["dmg_health"])

def player_death(event):
    damage[event["attacker"]][2].append(event["es_username"])
    player_menu(event["userid"])

def round_end(event):
    for player in [userid for userid in es.getUseridList() if not es.getplayerprop(userid, "CBasePlayer.pl.deadflag")]: player_menu(str(player))



#  MENU
def total_page(totalItem, maxIndex = 7):
    if totalItem < 2: totalPage = 1
    else:
        totalPage = totalItem / maxIndex
        if totalItem % maxIndex > 1: totalPage += 1
    return totalPage

def items_page(indexPage, totalPage, totalItem, maxIndex = 7):
    if indexPage < totalPage: element = maxIndex
    else: element = totalItem - (indexPage - 1) * maxIndex
    return element

def player_menu(userid):
    if not es.isbot(userid):
        global damage
        playerMenu = popuplib.active(userid)["name"]
        if playerMenu in popupList: popuplib.unsendname(playerMenu, userid)

        popupName = "hs_popup_%s" % userid
        popupList.add(popupName)
        popupMenu = popuplib.create(popupName)
        popupMenu.addline(getString("menu stat", userid))
        popupMenu.addline(" ")

        if not damage[userid][0]: popupMenu.addline("1. %s" % getString("menu receveid emptie", userid))
        else:
            popupMenu.addline("->1. %s" % getString("menu receveid", userid))
            popupMenu.submenu(1, "hs_received_%s_1" % userid)
            playerList = damage[userid][0].keys()
            playerNumb = len(playerList)
            pageTotal = total_page(playerNumb)
            pageIndex = 0

            while pageIndex < pageTotal:
                pageIndex += 1
                popupName = "hs_received_%s_%s" % (userid, pageIndex)
                popupList.add(popupName)

                itemTotal = items_page(pageIndex, pageTotal, playerNumb)
                itemIndex = 0
                popupRece = popuplib.create(popupName)
                popupRece.addline("%s     (%s/%s)" % (getString("menu receveid title", userid), pageIndex, pageTotal))
                popupRece.addline(" ")

                while itemIndex < itemTotal:
                    ListIndex = (pageIndex - 1) * 7 + itemIndex
                    itemIndex += 1
                    popupRece.addline("->%s. %s" % (itemIndex, playerList[ListIndex]))

                    popupName = "hs_received_%s_%s" % (userid, playerList[ListIndex])
                    popupStat = popuplib.create(popupName)
                    popupRece.submenu(itemIndex, popupName)
                    popupList.add(popupName)
                    popupStat.addline(getString("menu receveid player", userid, {"player" : playerList[ListIndex]}))
                    popupStat.addline(" ")
                    popupStat.addline(" ")
                    popupStat.addline(" ")
                    popupStat.addline(" ")

                    hitStat = damage[userid][0][playerList[ListIndex]]
                    hitIndex = 0
                    hitDamage = 0
                    hitTotal = 0
                    while hitIndex < 7:
                        if hitStat[hitIndex][0]:
                            hitDamage += hitStat[hitIndex][1]
                            hitTotal += hitStat[hitIndex][0]
                            popupStat.addline("%s: %s hit - %s hp" % (getString("zone %s" % hitIndex, userid), hitStat[hitIndex][0], hitStat[hitIndex][1]))
                        hitIndex += 1
                    popupStat.modline(3, getString("total damage", userid, {"healthpoint" : hitDamage}))
                    popupStat.modline(4, getString("total hit", userid, {"totalhit" : hitTotal}))
                    popupStat.addline(" ")
                    popupStat.addline("9. %s" % getString("menu back", userid))
                    popupStat.submenu(9, "hs_received_%s_%s" % (userid, pageIndex))
                    popupStat.addline("0. %s" % getString("menu exit", userid))

                popupRece.addline(" ")
                if pageIndex < pageTotal:
                    popupRece.addline("8. %s" % getString("menu next", userid))
                    popupRece.submenu(8, "hs_received_%s_%s" % (userid, pageIndex + 1))
                if pageIndex == 1:
                    popupRece.addline("9. %s" % getString("menu back", userid))
                    popupRece.submenu(9, "hs_popup_%s" % userid)
                else:
                    popupRece.addline("9. %s" % getString("menu back", userid))
                    popupRece.submenu(9, "hs_received_%s_%s" % (userid, pageIndex - 1))
                popupRece.addline("0. %s" % getString("menu exit", userid))

        if not damage[userid][1]: popupMenu.addline("2. %s" % getString("menu given emptie", userid))
        else:
            popupMenu.addline("->2. %s" % getString("menu given", userid))
            popupMenu.submenu(2, "hs_given_%s_1" % userid)
            playerList = damage[userid][1].keys()
            playerNumb = len(playerList)
            pageTotal = total_page(playerNumb)
            pageIndex = 0

            while pageIndex < pageTotal:
                pageIndex += 1
                popupName = "hs_given_%s_%s" % (userid, pageIndex)
                popupList.add(popupName)

                itemTotal = items_page(pageIndex, pageTotal, playerNumb)
                itemIndex = 0
                popupGive = popuplib.create(popupName)
                popupGive.addline("%s     (%s/%s)" % (getString("menu given title", userid), pageIndex, pageTotal))
                popupGive.addline(" ")

                while itemIndex < itemTotal:
                    ListIndex = (pageIndex - 1) * 7 + itemIndex
                    itemIndex += 1
                    popupGive.addline("->%s. %s" % (itemIndex, playerList[ListIndex]))

                    popupName = "hs_given_%s_%s" % (userid, playerList[ListIndex])
                    popupStat = popuplib.create(popupName)
                    popupGive.submenu(itemIndex, popupName)
                    popupList.add(popupName)
                    popupStat.addline(getString("menu given player", userid, {"player" : playerList[ListIndex]}))
                    popupStat.addline(" ")
                    popupStat.addline(" ")
                    popupStat.addline(" ")
                    popupStat.addline(" ")

                    hitStat = damage[userid][1][playerList[ListIndex]]
                    hitIndex = 0
                    hitDamage = 0
                    hitTotal = 0
                    while hitIndex < 7:
                        if hitStat[hitIndex][0]:
                            hitDamage += hitStat[hitIndex][1]
                            hitTotal += hitStat[hitIndex][0]
                            popupStat.addline("%s: %s hit - %s hp" % (getString("zone %s" % hitIndex, userid), hitStat[hitIndex][0], hitStat[hitIndex][1]))
                        hitIndex += 1
                    popupStat.modline(3, getString("total damage", userid, {"healthpoint" : hitDamage}))
                    popupStat.modline(4, getString("total hit", userid, {"totalhit" : hitTotal}))
                    popupStat.addline(" ")
                    popupStat.addline("9. %s" % getString("menu back", userid))
                    popupStat.submenu(9, "hs_given_%s_%s" % (userid, pageIndex))
                    popupStat.addline("0. %s" % getString("menu exit", userid))

                popupGive.addline(" ")
                if pageIndex < pageTotal:
                    popupGive.addline("8. %s" % getString("menu next", userid))
                    popupGive.submenu(8, "hs_given_%s_%s" % (userid, pageIndex + 1))
                if pageIndex == 1:
                    popupGive.addline("9. %s" % getString("menu back", userid))
                    popupGive.submenu(9, "hs_popup_%s" % userid)
                else:
                    popupGive.addline("9. %s" % getString("menu back", userid))
                    popupGive.submenu(9, "hs_given_%s_%s" % (userid, pageIndex - 1))
                popupGive.addline("0. %s" % getString("menu exit", userid))

        if not damage[userid][2]: popupMenu.addline("3. %s" % getString("menu killed emptie", userid))
        else:
            popupMenu.addline("->3. %s" % getString("menu killed", userid))
            popupMenu.submenu(3, "hs_killed_%s_1" % userid)
            playerList = damage[userid][2]
            playerNumb = len(playerList)
            pageTotal = total_page(playerNumb)
            pageIndex = 0

            while pageIndex < pageTotal:
                pageIndex += 1
                popupName = "hs_killed_%s_%s" % (userid, pageIndex)
                popupList.add(popupName)

                itemTotal = items_page(pageIndex, pageTotal, playerNumb)
                itemIndex = 0
                popupKill = popuplib.create(popupName)
                popupKill.addline("%s     (%s/%s)" % (getString("menu killed title", userid), pageIndex, pageTotal))
                popupKill.addline(" ")

                while itemIndex < itemTotal:
                    ListIndex = (pageIndex - 1) * 7 + itemIndex
                    itemIndex += 1
                    popupKill.addline("->%s. %s" % (itemIndex, playerList[ListIndex]))

                    popupName = "hs_killed_%s_%s" % (userid, playerList[ListIndex])
                    popupStat = popuplib.create(popupName)
                    popupKill.submenu(itemIndex, popupName)
                    popupList.add(popupName)
                    popupStat.addline(getString("menu killed player", userid, {"player" : playerList[ListIndex]}))
                    popupStat.addline(" ")
                    popupStat.addline(" ")
                    popupStat.addline(" ")
                    popupStat.addline(" ")

                    hitStat = damage[userid][1][playerList[ListIndex]]
                    hitIndex = 0
                    hitDamage = 0
                    hitTotal = 0
                    while hitIndex < 7:
                        if hitStat[hitIndex][0]:
                            hitDamage += hitStat[hitIndex][1]
                            hitTotal += hitStat[hitIndex][0]
                            popupStat.addline("%s: %s hit - %s hp" % (getString("zone %s" % hitIndex, userid), hitStat[hitIndex][0], hitStat[hitIndex][1]))
                        hitIndex += 1
                    popupStat.modline(3, getString("total damage", userid, {"healthpoint" : hitDamage}))
                    popupStat.modline(4, getString("total hit", userid, {"totalhit" : hitTotal}))
                    popupStat.addline(" ")
                    popupStat.addline("9. %s" % getString("menu back", userid))
                    popupStat.submenu(9, "hs_killed_%s_%s" % (userid, pageIndex))
                    popupStat.addline("0. %s" % getString("menu exit", userid))

                popupKill.addline(" ")
                if pageIndex < pageTotal:
                    popupKill.addline("8. %s" % getString("menu next", userid))
                    popupKill.submenu(8, "hs_killed_%s_%s" % (userid, pageIndex + 1))
                if pageIndex == 1:
                    popupKill.addline("9. %s" % getString("menu back", userid))
                    popupKill.submenu(9, "hs_popup_%s" % userid)
                else:
                    popupKill.addline("9. %s" % getString("menu back", userid))
                    popupKill.submenu(9, "hs_killed_%s_%s" % (userid, pageIndex - 1))
                popupKill.addline("0. %s" % getString("menu exit", userid))

        popupMenu.addline(" ")
        popupMenu.addline("0. %s" % getString("menu exit", userid))
        popupMenu.send(userid)
    damage[userid] = ({}, {}, [])
